#
# spec file for package ghc-folds
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name folds
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.7.3
Release:        lp150.1.8
Summary:        Beautiful Folding
License:        BSD-2-Clause
Group:          Development/Languages/Other
Url:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-adjunctions-devel
BuildRequires:  ghc-bifunctors-devel
BuildRequires:  ghc-cabal-doctest-devel
BuildRequires:  ghc-comonad-devel
BuildRequires:  ghc-constraints-devel
BuildRequires:  ghc-contravariant-devel
BuildRequires:  ghc-data-reify-devel
BuildRequires:  ghc-distributive-devel
BuildRequires:  ghc-lens-devel
BuildRequires:  ghc-mtl-devel
BuildRequires:  ghc-pointed-devel
BuildRequires:  ghc-profunctors-devel
BuildRequires:  ghc-reflection-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-semigroupoids-devel
BuildRequires:  ghc-transformers-devel
BuildRequires:  ghc-unordered-containers-devel
BuildRequires:  ghc-vector-devel
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if %{with tests}
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-deepseq-devel
BuildRequires:  ghc-directory-devel
BuildRequires:  ghc-doctest-devel
BuildRequires:  ghc-filepath-devel
BuildRequires:  ghc-hlint-devel
BuildRequires:  ghc-semigroups-devel
%endif

%description
This package is a playground full of comonadic folds.

This style of fold is documented in
<https://www.fpcomplete.com/user/edwardk/cellular-automata/part-2 "Cellular
Automata, Part II: PNGs and Moore">

This package can be seen as what happens if you chase Max Rabkin's
<http://squing.blogspot.com/2008/11/beautiful-folding.html "Beautiful Folding">
to its logical conclusion.

More information on this approach can be found in the
<http://conal.net/blog/posts/another-lovely-example-of-type-class-morphisms
"Another lovely example of type class morphisms"> and
<http://conal.net/blog/posts/more-beautiful-fold-zipping "More beautiful fold
zipping"> posts by Conal Elliott, as well as in Gabriel Gonzales'
<http://www.haskellforall.com/2013/08/composable-streaming-folds.html
"Composable Streaming Folds">.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Other
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%defattr(-,root,root,-)
%doc LICENSE

%files devel -f %{name}-devel.files
%defattr(-,root,root,-)
%doc CHANGELOG.markdown README.markdown

%changelog
* Wed May  3 2017 psimons@suse.com
- Update to version 0.7.3 with cabal2obs.
* Sun Feb 12 2017 psimons@suse.com
- Update to version 0.7.1 revision 1 with cabal2obs.
